#ifndef _SYS_SIGNAL_HH_
#define _SYS_SIGNAL_HH_

#include <unistd.h>
#include <signal.h>

#ifdef __linux__
#define SYS_SA_SINGLE    0x01
#define SYS_SA_MULTI     0x02
#endif

class Signal_Manager;
class Signal_Action;

/*
class Signal_Set
{
friend Signal_Action;
private:
#ifdef __osf__
  sigset_t  set;
#endif
public:
  Signal_Set();
  ~Signal_Set();
  int Add_Signal(int);
  int Rem_Signal(int);
};
*/

class Signal_Action
{
friend Signal_Manager;
private:
  struct sigaction  action;
public:
#ifdef __osf__
  Signal_Action(void(*)(int),int);
#endif
#ifdef __sun__
  Signal_Action(void(*)(int),int);
#endif
#ifdef __linux__
  Signal_Action(void(*)(int),int);
#endif
  ~Signal_Action();
  int Mask(int);
  //int Mask(Signal_Set&);
  //int UnMask(Signal_Set&);
};


class Signal_Manager
{
public:
  static int Send(pid_t,int);
  static int SetAction(int,Signal_Action&);
  static int SetDefaultAction(int);
  static int Block(int);
  static int UnBlock(int);
};

#endif











